unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, LCLType, StdCtrls, ComCtrls, Types, Math,

  {$ifdef arm}
  dglOpenGLSE,
  {$else}
  dglOpenGL,
  {$endif}

  Mesh, MyMath, Rad, Zylinder, Stange;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CoolBar1: TCoolBar;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    ScrollBar1: TScrollBar;
    Timer1: TTimer;
    ToggleBoxTimer: TToggleBox;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonWinkelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: integer);
    procedure OpenGLControl1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure OpenGLControl1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);






























  public
    BildPara: record
      zoom, x, y, xalt, yalt: single;
    end;

    Mesh: TMesh;

    TreibRad: record
      Richtung: (fwd, rwd);
      Radius, AufkeilWinkel: single;
      Rad: TRad;
      GegenKurbelZapfen_R, TreibZapfen_R: single;
    end;

    TreibGestaenge: record
      ZylinderAbstand: single;
      KuppelStange, Treibstange, KolbenStange: TStange;
      Kolben: TKolben
    end;

    SchiebeZylinder: record
      Top: single;
      Kolben: TKolben;
      SchieberStange: TStange;
    end;

    SchwingenGestaenge: record
      SchwingenLager_xy, HaengeEisen_xy: TPointF;
      SchwingenStange, Schwinge, SchieberSchubstange, SchieberSchubstangeAnsatz, HaengeEisen: TStange;
      HaengeEisenPos: record
        ZHubPos, mindesHub,
        min, max, Hub, HubPos: single;
      end;
    end;

    VoreilStangen: record
      Lenkeransatz_Height: single;
      Lenkeransatz,
      Lenkstange, VoreilHebel, VoreilHebelTop: TStange;
      KnieHbl: TGelenk;
    end;

    RadAbstand, speed, winkel: single;
    procedure BackGround;
  end;

var
  Form1: TForm1;

implementation

const
  m = 108.0;


{ TForm1 }

procedure TForm1.BackGround;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();

  glBegin(GL_QUADS);
  glColor3f(0.4, 0.2, 0.3);
  glVertex3f(-1.0, -1.0, 0.999);
  glColor3f(0.45, 0.25, 0.3);
  glVertex3f(+1.0, -1.0, 0.999);
  glColor3f(0.4, 0.25, 0.53);
  glVertex3f(+1.0, +1.0, 0.999);
  glColor3f(0.45, 0.2, 0.35);
  glVertex3f(-1.0, +1.0, 0.999);
  glEnd();

  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if ToggleBoxTimer.Checked then begin
    if TreibRad.Richtung = rwd then begin
      winkel += speed;
      if winkel > 360 then begin
        winkel -= 360;
      end;
    end else begin
      winkel -= speed;
      if winkel < 0 then begin
        winkel += 360;
      end;
    end;
  end;

  OpenGLControl1.Repaint;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  with  SchwingenGestaenge do begin
    HaengeEisen_xy.y := SchiebeZylinder.Top + HaengeEisen.Laenge + ScrollBar1.Position;
    with  HaengeEisenPos do begin
      HubPos := ScrollBar1.Position;
      if HaengeEisenPos.HubPos > 0 then begin
        TreibRad.Richtung := rwd;
      end else begin
        TreibRad.Richtung := fwd;
      end;
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  f: single;
begin
  InitOpenGL;
  ReadExtensions;
  ReadImplementationProperties;
  OpenGLControl1.MakeCurrent;

  with BildPara do begin
    zoom := 0.0007;
  end;

  with TreibRad do begin
    Radius := 500.0;
    //    TreibZapfen_R := 233;
    //    GegenKurbelZapfen_R := 215;
    TreibZapfen_R := 370;
    GegenKurbelZapfen_R := 185;
    AufkeilWinkel := -90.0;

    Rad := TRad.Create(Radius);
    RadAbstand := 1200.0;
  end;

  SchiebeZylinder.Top := 500.0;

  with TreibGestaenge do begin
    KuppelStange := TStange.Create(TreibRad.Radius / 8, RadAbstand, vec3(1.0, 0.2, 0.2));
    Treibstange := TStange.Create(TreibRad.Radius / 8, 2850, vec3(1.0, 0.2, 0.2));
    KolbenStange := TStange.Create(TreibRad.Radius / 8, TreibRad.TreibZapfen_R * 2, vec3(1.0, 0.2, 0.2));
    Kolben := TKolben.Create(TreibRad.TreibZapfen_R * 2, 200);
    ZylinderAbstand := Treibstange.Laenge;
  end;

  with SchwingenGestaenge do begin
    HaengeEisen_xy.x := 2050 - 440;

    with SchwingenLager_xy do begin
      x := 1890 + 50;  // (1890)
      y := 500;
    end;

    SchwingenStange := TStange.Create(TreibRad.Radius / 12, 1937.9, vec3(0.2, 1.0, 0.2));
    Schwinge := TStange.Create(TreibRad.Radius / 6, 405, vec3(0.2, 0.2, 1.0));

    SchieberSchubstange := TStange.Create(TreibRad.Radius / 12, 1400, vec3(1.0, 0.2, 0.2));
    SchieberSchubstangeAnsatz := TStange.Create(TreibRad.Radius / 12, 200, vec3(1.0, 0.2, 0.2));
    HaengeEisen := TStange.Create(TreibRad.Radius / 12, 500, vec3(1.0, 0.2, 0.2));

    with VoreilStangen do begin
      Lenkeransatz_Height := 195;
      //      VoreilHebel := TStange.Create(TreibRad.Radius / 12, 711, vec3(1.0, 1.2, 0.2));
      VoreilHebel := TStange.Create(TreibRad.Radius / 12, 725, vec3(1.0, 1.2, 0.2));
      Lenkstange := TStange.Create(TreibRad.Radius / 12, 441, vec3(1.0, 0.2, 0.2));
      Lenkeransatz := TStange.Create(TreibRad.Radius / 12, Lenkeransatz_Height, vec3(1.0, 0.2, 0.2));
      VoreilHebelTop := TStange.Create(TreibRad.Radius / 12, m, vec3(1.0, 0.2, 0.2));
    end;

    with SchiebeZylinder do begin
      Kolben := TKolben.Create(TreibRad.GegenKurbelZapfen_R * 2, 100);
      SchieberStange := TStange.Create(TreibRad.Radius / 12, TreibRad.GegenKurbelZapfen_R * 2, vec3(1.0, 0.2, 0.2));
    end;

    with HaengeEisenPos do begin
      f := VoreilStangen.VoreilHebel.Laenge;
      mindesHub := TreibRad.TreibZapfen_R * 2 / f * m / 1.5;

      //      mindesHub:=SchiebeZylinder.SchieberStange.Laenge/1.5;

      //      Caption := FloatToStr(mindesHub);

      min := -300;
      max := 300;
      Hub := max - min;
      //    mindesHub := 50;

      //      HubPos := max;
      HubPos := 0;
      ScrollBar1.Min := round(min);
      ScrollBar1.Max := round(max);
      ScrollBar1.Position := round(HubPos);
      ScrollBar1Change(Sender);
    end;
  end;

  Mesh := TMesh.Create;

  speed := 3.10344;

  Trigo.Grad := True;
  Timer1.Enabled := True;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var
  SchieberHubPos, KKopf_x, f, w, KKopfSchieber: single;
  KSchwingeVoreil, KSchwinge_SchwingExz: TKurbelSchwinge;
  TreibStange_SchubKurbel: TSchubKurbel;

  p: TPointf;

  Virtuall: record
    SchwingeSchubKurbel: TSchubKurbel;
  end;

begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  BackGround;

  // --- Bremsklötze

  with TreibRad do begin
    glTranslatef(-RadAbstand * 2, 0.0, 0.0);
    Mesh.Arc2(Radius * 1.2, Radius * 1.4, 0, 60); // deutet eine KSchwinge_SchwingExz an
    glColor3f(1, 1, 1);
    Mesh.Arc2(Radius * 1.2, Radius * 1.4, 90, 180.0); // deutet eine KSchwinge_SchwingExz an
    glColor3f(1, 0.1, 1);
    if winkel < 180.0 then begin
      glRotatef(winkel / 10, 0.0, 0.0, 1.0);
    end else begin
      glRotatef(180.0 / 10 - (winkel / 10 - 180.0 / 10), 0.0, 0.0, 1.0);
    end;
    Mesh.Arc2(Radius * 1.4, Radius * 1.6, -30, 30); // deutet eine KSchwinge_SchwingExz an

    glLoadIdentity();
  end;

  // --- Treibrad


  with TreibRad do begin
    Rad.Draw(winkel);
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);
    glTranslatef(-RadAbstand, 0.0, 0.0);
    Rad.Draw(winkel);

    glLoadIdentity();
  end;


  with TreibGestaenge do begin

    with TreibStange_SchubKurbel do begin
      SetPara(winkel, TreibRad.TreibZapfen_R, Treibstange.Laenge);

      // --- KuppelStange

      with A_xy do begin
        glTranslatef(x, y, 0);
        glTranslatef(-RadAbstand, 0.0, -0.03);
        KuppelStange.Draw;
        glTranslatef(-RadAbstand, 0.0, 0.0);
        KuppelStange.Draw;
        glLoadIdentity();
      end;


      // --- Treibstange

      glTranslatef(B_x, 0.0, -0.03);
      glRotatef(Pleuel_W, 0.0, 0.0, 1.0);
      Treibstange.Draw;
      glLoadIdentity();
      KKopf_x := B_x;
    end;


    // --- Kolben

    glTranslatef(KKopf_x, 0.0, 0.0);
    KolbenStange.Draw;
    glLoadIdentity();

    glTranslatef(ZylinderAbstand + KolbenStange.Laenge, 0.0, 0.0);

    SchieberHubPos := KKopf_x - Treibstange.Laenge + TreibRad.TreibZapfen_R;
    Kolben.Draw(SchieberHubPos);
    glLoadIdentity();

    // --- Schwinge ---

    with SchwingenGestaenge do begin
      KSchwinge_SchwingExz.SetParam(winkel + TreibRad.AufkeilWinkel, TreibRad.GegenKurbelZapfen_R, SchwingenLager_xy,
        SchwingenStange.Laenge, Schwinge.Laenge, True);

      // Schwingenstange

      glTranslatef(KSchwinge_SchwingExz.A_xy.x, KSchwinge_SchwingExz.A_xy.y, -0.2);
      glRotatef(KSchwinge_SchwingExz.Pleuel_W, 0.0, 0.0, 1.0);
      SchwingenStange.Draw;
      glLoadIdentity();

      // Schwinge

      with SchwingenLager_xy do begin
        glTranslatef(x, y, -0.2);
        glRotatef(KSchwinge_SchwingExz.Schwinge_W, 0.0, 0.0, 1.0);
        Schwinge.Draw;
        glRotatef(180, 0.0, 0.0, 1.0);
        Schwinge.Draw;
        glLoadIdentity();
      end;

    end;

  end;

  // -------------------------
  // --- Virtuelle Stangen ---
  // -------------------------

  // SchieberSchubStange

  with SchwingenGestaenge do begin

    with HaengeEisenPos do begin
      Caption := FloatToStr(HubPos);
      f := min / HubPos;
      f := f * 1.5;
    end;

    with Virtuall.SchwingeSchubKurbel do begin
      SetPara(KSchwinge_SchwingExz.Schwinge_W, Schwinge.Laenge / f, SchieberSchubstange.Laenge);

      with SchwingenLager_xy do begin
        KKopfSchieber := x + B_x;
        glTranslatef(x + B_x, y, -0.2);
      end;

      glRotatef(Pleuel_W, 0.0, 0.0, 1.0);
    end;
    SchieberSchubstange.Draw(vec3(0.5, 0.5, 0.5));
    glLoadIdentity();
  end;


  // --- VoreilStangen

  with VoreilStangen do begin
    KnieHbl.SetParam(PointF(KKopf_x, -Lenkeransatz_Height), PointF(KKopfSchieber, SchiebeZylinder.Top), Lenkstange.Laenge, VoreilHebel.Laenge, True);
    glTranslatef(KKopf_x, 0, 0);

    glPushMatrix;
    glRotatef(-90, 0.0, 0.0, 0.1);
    Lenkeransatz.Draw;
    glPopMatrix;

    glTranslatef(0.0, -Lenkeransatz_Height, 0.0);
    glRotatef(KnieHbl.Kurbel_W, 0.0, 0.0, 0.1);
    Lenkstange.Draw(vec3(0.5, 0.5, 0.5));
    glLoadIdentity();

    glTranslatef(KKopfSchieber, SchiebeZylinder.Top, 0);
    glRotatef(KnieHbl.Pleuel_W, 0.0, 0.0, 0.1);
    VoreilHebel.Draw(vec3(0.5, 0.5, 0.5));
    glTranslatef(-VoreilHebelTop.Laenge, 0.0, 0.0);
    VoreilHebelTop.Draw(vec3(0.5, 0.5, 0.5));
    glLoadIdentity();


    p := Trigo.Alpha_c_To_xy(KnieHbl.Pleuel_W, m);
    glTranslatef(KKopfSchieber - p.x, SchiebeZylinder.Top - p.y, 0.0);
    VoreilHebelTop.Draw(vec3(0.5, 1.0, 0.5));
    glLoadIdentity();

    KKopfSchieber := KKopfSchieber - p.x;
  end;

  // ------------------------------
  // --- Ende Virtuelle Stangen ---
  // ------------------------------

  // Kolben Schieber


  with TreibGestaenge do begin

    //with SchwingenGestaenge.HaengeEisenPos do begin
    //  w := (abs(HubPos / max * (max - mindesHub)) + mindesHub) / Hub * 2;
    //end;

    //with SchwingenGestaenge.HaengeEisenPos do begin
    //  f := TreibRad.AufkeilWinkel;
    //  f := f / max * abs(HubPos) + 180;
    //end;
    //if TreibRad.Richtung = fwd then begin
    //  f := winkel - f;
    //end else begin
    //  f := winkel + f;
    //end;

    //p := Trigo.Alpha_c_To_xy(f, TreibRad.GegenKurbelZapfen_R);
    //f := sqrt(sqr(Treibstange.Laenge) - sqr(p.y * w)) + p.x * w;
    //SchieberHubPos := f - Treibstange.Laenge + TreibRad.TreibZapfen_R - (TreibRad.TreibZapfen_R - TreibRad.GegenKurbelZapfen_R);

    glTranslatef(ZylinderAbstand + KolbenStange.Laenge, SchiebeZylinder.Top, 0.0);
    //    SchiebeZylinder.Kolben.Draw(SchieberHubPos);


    SchiebeZylinder.Kolben.Draw(KKopfSchieber - TreibGestaenge.Treibstange.Laenge - SchiebeZylinder.SchieberStange.Laenge);
    glLoadIdentity();
  end;

  //  KKopfSchieber := f + SchiebeZylinder.SchieberStange.Laenge;

  // --- VoreilStangen

  with VoreilStangen do begin
    KnieHbl.SetParam(PointF(KKopf_x, -Lenkeransatz_Height), PointF(KKopfSchieber, SchiebeZylinder.Top), Lenkstange.Laenge, VoreilHebel.Laenge, True);
    glTranslatef(KKopf_x, 0, 0);

    glPushMatrix;
    glRotatef(-90, 0.0, 0.0, 0.1);
    Lenkeransatz.Draw;
    glPopMatrix;

    glTranslatef(0.0, -Lenkeransatz_Height, 0.0);


    glRotatef(KnieHbl.Kurbel_W, 0.0, 0.0, 0.1);
    Lenkstange.Draw;
    glLoadIdentity();

    glTranslatef(KKopfSchieber, SchiebeZylinder.Top, 0);
    glRotatef(KnieHbl.Pleuel_W, 0.0, 0.0, 0.1);
    VoreilHebel.Draw;
    //    glTranslatef(VoreilHebelTop.Laenge, 0.0, 0.0);
    VoreilHebelTop.Draw;
    glLoadIdentity();
  end;


  // --- SchwingenGestaenge ---

  with SchwingenGestaenge do begin

    KSchwingeVoreil.SetParam(VoreilStangen.KnieHbl.Pleuel_W + 180, -VoreilStangen.VoreilHebelTop.Laenge,
      PointF(HaengeEisen_xy.x - KKopfSchieber, HaengeEisen_xy.y - SchiebeZylinder.Top),
      SchieberSchubstange.Laenge + SchieberSchubstangeAnsatz.Laenge, HaengeEisen.Laenge);


    // SchieberSchubStange

    glTranslatef(KSchwingeVoreil.A_xy.x + KKopfSchieber, KSchwingeVoreil.A_xy.y + SchiebeZylinder.Top, -0.2);
    glRotatef(KSchwingeVoreil.Pleuel_W, 0.0, 0.0, 1.0);
    SchieberSchubstange.Draw;
    glTranslatef(SchieberSchubstange.Laenge, 0.0, 0.0);
    SchieberSchubstangeAnsatz.Draw();
    glLoadIdentity();


    // Hänge-Eisen

    with HaengeEisen_xy do begin
      glTranslatef(x, y, -0.2);
    end;

    glRotatef(KSchwingeVoreil.Schwinge_W, 0.0, 0.0, 1.0);
    HaengeEisen.Draw;
    glLoadIdentity();

  end;

  // --- SchiebeZylinder


  glTranslatef(KKopfSchieber, SchiebeZylinder.Top, -0.2);
  SchiebeZylinder.SchieberStange.Draw;
  glLoadIdentity();

  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  with TreibRad do begin
    Rad.Free;
  end;

  with  SchiebeZylinder do begin
    Kolben.Free;
    SchieberStange.Free;
  end;

  with TreibGestaenge do begin
    KuppelStange.Free;
    Treibstange.Free;
    KolbenStange.Free;
    Kolben.Free;
  end;

  with SchwingenGestaenge do begin
    SchieberSchubstange.Free;
    SchieberSchubstangeAnsatz.Free;
    HaengeEisen.Free;
    SchwingenStange.Free;
    Schwinge.Free;
  end;

  with VoreilStangen do begin
    Lenkeransatz.Free;
    Lenkstange.Free;
    VoreilHebel.Free;
    VoreilHebelTop.Free;
  end;

  Mesh.Free;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);

    with BildPara do begin
      glTranslatef(BildPara.x, BildPara.y, 0.0);
      glScalef(zoom, zoom, zoom);
    end;
  end;
end;

procedure TForm1.OpenGLControl1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
const
  Step = 0.0050;
begin
  if Shift = [ssLeft] then begin
    BildPara.x += (X - BildPara.xalt) * Step;
    BildPara.y += -(Y - BildPara.yalt) * Step;
    OpenGLControl1Resize(Sender);
  end;
  BildPara.xalt := x;
  BildPara.yalt := y;
end;

procedure TForm1.OpenGLControl1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: boolean);
begin
  BildPara.zoom *= 1.05;
  OpenGLControl1Resize(Sender);
end;

procedure TForm1.OpenGLControl1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: boolean);
begin
  BildPara.zoom /= 1.05;
  OpenGLControl1Resize(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

procedure TForm1.ButtonWinkelClick(Sender: TObject);
begin
  case TButton(Sender).Tag of
    0: begin
      winkel := 0;
    end;
    90: begin
      winkel := 90;
    end;
    180: begin
      winkel := 180;
    end;
    270: begin
      winkel := 270;
    end;
  end;

end;

initialization

  {$I unit1.lrs}

end.
